unit ASFSampleMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ActnList, asfClasses, asfActions, ComCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    Demo1: TMenuItem;
    LogIn: TMenuItem;
    LogOut: TMenuItem;
    N1: TMenuItem;
    Exit: TMenuItem;
    ActionList: TActionList;
    TestAction1: TAppSecurityAction;
    est1: TMenuItem;
    EnableTest: TCheckBox;
    Label1: TLabel;
    Administration1: TMenuItem;
    GenerateDatabase: TMenuItem;
    EditUsers: TMenuItem;
    EditRoles: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    TestAction2: TAppSecurityAction;
    est21: TMenuItem;
    StatusBar: TStatusBar;
    Image: TImage;
    ShowLog: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ActionListUpdate(Action: TBasicAction; var Handled: Boolean);
    procedure EditRolesClick(Sender: TObject);
    procedure EditUsersClick(Sender: TObject);
    procedure EnableTestClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure GenerateDatabaseClick(Sender: TObject);
    procedure LogInClick(Sender: TObject);
    procedure LogOutClick(Sender: TObject);
    procedure ShowLogClick(Sender: TObject);
    procedure TestAction1Execute(Sender: TObject);
    procedure TestAction2Execute(Sender: TObject);
  private
    procedure AppSecurityLogin(Sender: TObject);
    procedure AppSecurityLogout(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses asfUserAccessEditor, asfLogViewer, ASFSampleViewImage;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  DefaultAppSecurity.OnLogin := AppSecurityLogin;
  DefaultAppSecurity.OnLogout := AppSecurityLogout;
  DefaultAppSecurity.Active := True;
end;

procedure TMainForm.AppSecurityLogin(Sender: TObject);
begin
  StatusBar.SimpleText := ': ' + DefaultAppSecurity.CurrentUser.FullName;
  DefaultAppSecurity.SetupFormAccess(Self);
end;

procedure TMainForm.AppSecurityLogout(Sender: TObject);
begin
  StatusBar.SimpleText := '';
end;

procedure TMainForm.ActionListUpdate(Action: TBasicAction; var Handled:
  Boolean);
begin
  LogIn.Enabled := DefaultAppSecurity.State <> ssLoggedIn;
  LogOut.Enabled := DefaultAppSecurity.State = ssLoggedIn;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  DefaultAppSecurity.Logout;
end;

procedure TMainForm.ExitClick(Sender: TObject);
begin
  Close
end;

procedure TMainForm.LogInClick(Sender: TObject);
begin
  DefaultAppSecurity.Login
end;

procedure TMainForm.LogOutClick(Sender: TObject);
begin
  DefaultAppSecurity.Logout;
end;

procedure TMainForm.EnableTestClick(Sender: TObject);
begin
  TestAction1.Enabled := EnableTest.Checked
end;

procedure TMainForm.GenerateDatabaseClick(Sender: TObject);
begin
  DefaultAppSecurity.GenerateDatabase;
end;

procedure TMainForm.EditRolesClick(Sender: TObject);
begin
  ShowUserAccessEditor(DefaultAppSecurity, False);
end;

procedure TMainForm.EditUsersClick(Sender: TObject);
begin
  ShowUserAccessEditor(DefaultAppSecurity, True);
end;

procedure TMainForm.ShowLogClick(Sender: TObject);
begin
  ShowSecurityLog(DefaultAppSecurity)
end;

procedure TMainForm.TestAction1Execute(Sender: TObject);
begin
  ShowMessage('Test 1 action clicked');
  {         }
  DefaultAppSecurity.AddLogRecord(100, 'Test 1 action clicked', Image.Picture.Bitmap);
end;

procedure TMainForm.TestAction2Execute(Sender: TObject);
begin
  ShowMessage('Test 2 action clicked');
end;

end.
