unit asfRolesEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, asfBaseUserEditor, ActnList, asfClasses, StdCtrls, ComCtrls,
  cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, ImgList,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, DB;

type
  TfrmRolesEditor = class(TfrmBaseUserEditor)
    procedure AddActionExecute(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure SetupForm; override;
    function EditObject(ObjectID: Integer): Boolean; override;
    procedure EditObjectAccess(ObjectID: Integer); override;
  public
    { Public declarations }
  end;

var
  frmRolesEditor: TfrmRolesEditor;

implementation

uses
  asfAccessEditor, asfData;

{$R *.dfm}

procedure TfrmRolesEditor.AddActionExecute(Sender: TObject);
var
  RoleName: String;
begin
  inherited;
  if InputQuery(' ', ' ', RoleName) then
    AddRecord(RoleName, RoleObjectType);
end;

procedure TfrmRolesEditor.SetupForm;
begin
  with AppSecurity.DataProvider, DBStructure do
  begin
    NameField := RoleTableNameField;
    IdField := RoleTableRoleIDField;
    ParentIdField := RoleTableParentIDField;
    ObjectTypeField := RoleTableObjectTypeField;
    ShowData(GetRolesTable);
    TreeList.FullExpand;
  end;
end;

function TfrmRolesEditor.EditObject(ObjectID: Integer): Boolean;
var
  RoleName: String;
begin
  RoleName := DataSource.DataSet.FieldByName(NameField).AsString;
  if InputQuery(' ', ' ', RoleName) then
  with DataSource.DataSet do
  begin
    Edit;
    FieldByName(NameField).AsString := RoleName;
    Post;
  end;
  Result := False; {    Refresh }
end;

procedure TfrmRolesEditor.EditObjectAccess(ObjectID: Integer);
begin
  ShowAccessEditor(AppSecurity, False, ObjectID);
end;

end.
