unit asfUsersEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, asfBaseUserEditor, ActnList, asfClasses, StdCtrls, ComCtrls,
  cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, ImgList,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, DB, asfActions, cxTextEdit,
  cxDropDownEdit;

type
  TfrmUsersEditor = class(TfrmBaseUserEditor)
    procedure AddActionExecute(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure SetupForm; override;
    function EditObject(ObjectID: Integer): Boolean; override;
    procedure EditObjectAccess(ObjectID: Integer); override;
  public
    { Public declarations }
  end;

var
  frmUsersEditor: TfrmUsersEditor;

implementation

uses
  asfUserEditor, asfAccessEditor;

{$R *.dfm}

procedure TfrmUsersEditor.SetupForm;
begin
  with AppSecurity.DataProvider, DBStructure do
  begin
    NameField := UserTableFullNameField;
    IdField := UserTableUserIDField;
    ParentIdField := UserTableParentIDField;
    ObjectTypeField := UserTableObjectTypeField;
    ShowData(GetUsersTable);
    TreeList.FullExpand;
  end;
end;

procedure TfrmUsersEditor.AddActionExecute(Sender: TObject);
var
  UserID: Integer;
  UserName: String;
begin
  inherited;
  if InputQuery(' ', ' ', UserName) then
  begin
    UserID := AppSecurity.AddUser(UserName, '', '', AppSecurity.Model.DisabledState);
    if AppSecurity.LogOptions.RegisterUserAccountAdd then
      AppSecurity.AddLogRecord(lmUserAccountAdd, AppSecurity.LogOptions.UserAccountAddMessage + UserName);
    RefreshDataSet(UserID);
  end;
end;

function TfrmUsersEditor.EditObject(ObjectID: Integer): Boolean;
begin
  Result := EditUser(AppSecurity, ObjectID)
end;

procedure TfrmUsersEditor.EditObjectAccess(ObjectID: Integer);
begin
  ShowAccessEditor(AppSecurity, True, ObjectID);
end;

end.
