unit asfReg;

interface

uses Classes, DesignIntf, DesignEditors;

type
  TModelEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TFormControllerlEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure Register;

implementation

uses ActnList, asfClasses, asfModel, asfModelTreeView, asfModelEditor,
  asfFormControllerEditor, asfData, asfActions;

{$R *.dcr}

procedure Register;
begin
  RegisterComponents('ASF', [TAppSecurity,
    TAppSecurityModel, TAppSecurityModelTreeView,
    TAppSecurityDataProvider,
    TAppSecurityFormController, TAppSecurityFormController,
    TAppSecurityFormAccessItem]);
  RegisterActions('ASF', [TAppSecurityAction], nil);

  {    }
  RegisterComponentEditor(TAppSecurityModel, TModelEditor);
  RegisterComponentEditor(TAppSecurityFormController, TFormControllerlEditor);
end;

{ TModelEditor }

procedure TModelEditor.ExecuteVerb(Index: Integer);
begin
  inherited;
  if Index = 0 then
    if ShowModelEditor(Component as TAppSecurityModel) then Designer.Modified;
end;

function TModelEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := ' ..';
    else Result := inherited GetVerb(Index)
  end
end;

function TModelEditor.GetVerbCount: Integer;
begin
  Result := 1
end;

{ TFormControllerlEditor }

procedure TFormControllerlEditor.ExecuteVerb(Index: Integer);
begin
  inherited;
  if Index = 0 then
    if ShowFormControllerEditor(Component as TAppSecurityFormController, Component.Owner)
      then Designer.Modified;
end;

function TFormControllerlEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := ' ..';
    else Result := inherited GetVerb(Index)
  end
end;

function TFormControllerlEditor.GetVerbCount: Integer;
begin
  Result := 1
end;

end.
